#!/usr/bin/env python

from urllib import quote, urlencode
import mimetypes

class postbase:

    def get_cookies(self, headers):

        ck = {}
        for h in headers.getheaders('Set-Cookie'):
            equals = h.find('=')
            semi = h.find(';', equals)
            name = h[: equals]
            val = h[equals+1: semi]
            ck[name] = val
            print "cookie: %s %s\n" % (name, val)

        return ck

    def add_cookies(self, ck, cooks=None):

        if cooks is None:
            cooks = ck.keys()

        self.h.putheader('Cookie2', '$VERSION="1"')
        ckl = []
        for k in cooks:
            ckl.append("%s=%s;" % (k, ck[k]))
        self.h.putheader('Cookie', ' '.join(ckl))


    def post(self, url, data):

        self.h.putrequest('POST', url)
        self.add_cookies(self.sc)
        self.h.putheader('Content-type', 'application/x-www-form-urlencoded')
        self.h.putheader('Content-length', '%d' % (len(data)))
        self.h.endheaders()
        self.h.send(data + chr(13)+chr(10))

    def post_multipart(self, url, fields, files):
        """
        Post fields and files to an http host as multipart/form-data.
        fields is a sequence of (name, value) elements for regular form fields.
        files is a sequence of (name, filename, value) elements for data to be uploaded as files
        Return the server's response page.
        """
        content_type, body = encode_multipart_formdata(fields, files)
        self.h.putrequest('POST', url)
        self.add_cookies(self.sc)
        self.h.putheader('content-type', content_type)
        self.h.putheader('content-length', str(len(body)))
        self.h.endheaders()
        self.h.send(body)

def encode_multipart_formdata(fields, files):
    """
    fields is a sequence of (name, value) elements for regular form fields.
    files is a sequence of (name, filename, value) elements for data to be uploaded as files
    Return (content_type, body) ready for httplib.HTTP instance
    """
    BOUNDARY = '----------ThIs_Is_tHe_bouNdaRY_$'
    CRLF = '\r\n'
    L = []
    for (key, value) in fields:
        L.append('--' + BOUNDARY)
        L.append('Content-Disposition: form-data; name="%s"' % key)
        L.append('')
        L.append(value)
    for (key, filename, value) in files:
        L.append('--' + BOUNDARY)
        L.append('Content-Disposition: form-data; name="%s"; filename="%s"' % (key, filename))
        L.append('Content-Type: %s' % get_content_type(filename))
        L.append('')
        L.append(value)
    L.append('--' + BOUNDARY + '--')
    L.append('')
    body = CRLF.join(L)
    content_type = 'multipart/form-data; boundary=%s' % BOUNDARY
    return content_type, body

def get_content_type(filename):
    return mimetypes.guess_type(filename)[0] or 'text/x-diff'

